<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>CS 1653 Project P5 Writeup</title>
  <style>
/* BEGIN CHANGES HERE */

/* In this section, you may add CSS styling if desired */
header {
  text-align: center;
}

table, th, td {
    border: 1px solid black;
}

body {
    margin: 40px auto;
    max-width: 62%;
    line-height: 1.6;
    font-size: 18px;
    color: #444;
    padding: 0 10px;
}

/* END CHANGES HERE */
  </style>
  <body>
    <header>
      <h1>CS 1653 Project P5 Writeup</h1>
      <h2>
<!-- BEGIN CHANGES HERE -->

      <p>Christopher Constantino</p>
      <p>Jordon Rapoport</p>
      <p>Michael Stoltz</p>

<!-- END CHANGES HERE -->
      </h2>
    </header>
    <section id="overview">
      <h2>Overview</h2>
<!-- BEGIN CHANGES HERE -->

<p>For this phase of the project we will build on the threat models of all the
previous phases. We will place even less trust on the clients and file servers,
and consider threats posed by other entities in the system.</p>

<p>Under the threat model we are using, we have come up with six threats that
are present. They are as follows:</p>

<ul>
<li><em>Token hoarding</em> is when a user hangs on to a token for use with
file servers. The user could have been removed from a group on the group
server, but still use this old token to access that group’s files on the file
servers.</li>
<li><em>Token theft</em> is when a user or a file server steals another
user’s token to be used for its own ends.</li>
<li><em>File server file tampering</em> is the ability for the file servers to
modify files in a malicious way without the user knowing.</li>
<li>attackers attempting to log in as other users by repeatedly guessing passwords.</li>
<li><em>(Distributed) denial of service</em> is when a malicious principal
attempts to deny service to users, e.g. by wasting scarce resources. </li>
<li><em>Password brute forcing</em> is when an attacker tries to gain the
identity and concomitant permissions of another user by guessing that user’s
password.</li>
<li><em>Group server impersonation</em> is when an intruder uses knowledge of
the SRP verifiers that are normally only known by the group server or to users,
who can generate their own particular verifiers.</li>
</ul>

<p>In order to combat these threats we will propose, and implement a few,
countermeasures. These countermeasures will include using timestamps to make
tokens expire, hashing files to check for integrity, and putting requirements
in place for password creation along with a limit on tries for password
entry.</p>

<!-- END CHANGES HERE -->
    </section>
    <section id="threatmodel">
      <h2>Threat Model</h2>
<!-- BEGIN CHANGES HERE -->

<p>For all of our possible attacks we will be using an extension to the threat
models from previous phases of the project:</p>
<li><strong>Group Server</strong>
The group server remains mostly trustworthy. It is assumed to only issue tokens
to properly authenticated clients, properly enforce the constraints on group
operations, and to not allow its private key to be compromised. The group
server shares no secrets with the file servers and never directly communicates
with them.
</li>
<li><strong>File Servers</strong>
File servers are assumed to be largely untrusted. We expect them to possible
leak files to unauthorized users, to attempt to steal user tokens, or to tamper
with or delete files stored on it.
</li>
<li><strong>Clients</strong>
We will assume that clients are not trustworthy. They may attempt to obtain
tokens that belong to other users, modify the tokens issued to them by the
group server to acquire additional permissions, and to collect tokens for the
purpose of attempting to retain permissions that would otherwise be lost over
time, such as in between sessions.
</li>
<li>
<strong>Other Principals</strong>
We assume that all communications in the system might be intercepted by an
active attacker who can insert, reorder, replay, or modify messages. Attackers
may also attempt to maliciously deny service to other users, such as by using
up a server’s resources. They may attempt to impersonate other principals, e.g.
by behaving as a man in the middle, by attempting to steal tokens that a user
or file server might not have discarded, or by attempting to guess the log-in
information of users.
</li>

<!-- END CHANGES HERE -->
    </section>
    <section id="attack">
      <h2>Attacks</h2>
<!-- BEGIN CHANGES HERE -->

<h3>Token Hoarding</h3>
<p>The first threat we will address is a special case of Threat 7 from the
previous phase. Our solution then provides secure revocations between sessions,
but is vulnerable to an attacker who maintains an open connection. The
attacker’s token remains valid in the eyes of the file servers, although the
group server detects when a token has an incorrect state.</p>

<p>The consequence of this is that an attacker is able to download encrypted
versions of files belonging to groups that he was removed from. Because the
group server is able to (and does) verify the consistency of the token’s
contents with its own internal information about the user’s permissions, the
user is not able to use this token to obtain the keys by which any new or
changed files belonging to his former group could be decrypted. Essentially,
so long as our assumptions about the security of AES-128 in OFB mode hold, no
secret information is compromised that the removed user did not already have
access to at some point.</p>

<p>Despite this, it is true that making the encrypted files more obscure could
in the long run allow the system to remain more secure. Some attack on AES
could be discovered that would feasibly allow for the retrieval of plaintext
from ciphertext, in which case we would want these encrypted files in as few
hands as possible.</p>

<h3>Token Theft</h3>
<p>Another consequence of users being able to store tokens (particularly in
their unencrypted forms) is that attackers have an additional vector by which
tokens can be compromised. Namely, as long as a token is in the possession of
a user, it is at risk of being taken from his possession. File servers also
pose a threat here, because they have access to unencrypted user tokens; a
file server under control of an attacker could be used to harvest user tokens
which would subsequently be used to access files on other file servers or to
manipulate group permissions and afford the attacker new privileges in the
system.</p>

<p>In phase 4, we partially addressed this threat by extending our
token-handling procedure so that a compliant server will reject any token not
intended for it (if the server is not compliant, then it has far easier means
of compromising the security of the information with which it was entrusted
than by requiring an attacker to get ahold of a token). Nevertheless, this
measure only limits the scope of the potential damage that can be caused by
a token being compromised. This goes back to our design principle of fault
tolerance, i.e. that a compromise in one aspect should propagate as little as
possible to the other aspects of the system.</p>

<p>What we did <em>not</em> address in phase 4 is the issue that, once issued,
a token becomes <em>the</em> token for a particular user and remains valid
in the eyes of the file servers indefinitely. This state of affairs is in
contradiction with our Minimum Window of Opportunity principle from phase 1,
which states that the duration for which an aspect of the system is at risk of
being compromised should be minimal.</p>

<h3>File Server File Tampering</h3>
<p>File servers are largely untrusted. If malicious, a file server is fully
capable of tampering with or deleting the files that are stored on it. Although
the files stored on it are now encrypted, it can still make changes that can
cause issues for the user. For example the file server could change the saved
file to be some sort of malicious file that would harm a user’s computer. Or
perhaps changing it could cause issues for the program intending to open a file
it was not expecting to be malformed.</p>

<p>The mode with which we encrypt files (OFB) does not allow for very useful
modifications to be made to encrypted files, e.g. by overwriting one encrypted
block with another. But as a general matter, we want to follow the fail fast
principle; if something goes wrong, like a file being corrupted or tampered
with, we want everyone to whom it may be a concern to be loudly and immediately
notified of the fact.</p>

<h3>(Distributed) Denial of Service ((D)DOS)</h3>
<p>Systems are designed to be secure because security is a useful property to
have. Even more useful than security is for the system to actually work, which
is what DOS and DDOS attacks seek to prevent. The design of our system is
particularly at risk of DOS attacks because its usefulness depends on the
continuing operation of the group server.</p>

<p>The group server has finite resources with which it can handle requests from
users. Our threat model allows for an unbounded number of other entities to
join the system, and any interaction with the group server (even benign
interaction) causes it to use up these resources.</p>

<p>We have included a program, <code>DOS.java</code>, which demonstrates
how even a single attacker is able to bring down the group server when
no protections exist. Running it will cause the group server’s memory
and CPU usage footprints to explode before it eventually runs out of
socket descriptors and becomes unable to open any further connections. See
<code>compile.txt</code> and <code>usage.txt</code> for information about how
to use it.</p>

<h3>Password Brute Forcing</h3>
<p>Our current implementation allows the administrator to create users’
passwords. The admin has the freedom to set the password to whatever he likes
so long as the password is not null or the empty string. People tend to create
weak passwords which makes it significantly easier for a brute force attack
to succeed because the amount of passwords that users are likely to use is
usually orders of magnitude less than the entire search space of possibilities
. This sort of vulnerability leaves the users in the system open to a brute
force attack. An adversary can simply create a program that loops through a
dictionary, attempting a list of common passwords until one of them is correct,
allowing the adversary to obtain a token identifying him as some other user.
The program could run through millions of attempts in a matter of seconds and
have access to many unsecured accounts. This threat is exacerbated by our
protocol not having any sort of timeout measure. There is nothing to stop a
malicious user from trying thousands or millions of attempts because there is
no penalty for attempting to log in with a wrong password, i.e. the attacker
won’t be locked out by the server. A user entering a password wrong, say, five
times is more likely that an attacker trying to gain unauthorized access. The
latter does happen, but it’s better to err on the side of caution when taking
security into account.</p>

<h3>Group Server Impersonation</h3>
<p>Our use of the SRP protocol opens up an interesting vulnerability. In
order to authenticate users, the group server stores a salt and a verifier
<var>v = g<sup>H(salt, username, password) (mod N)</var>. An attacker who
gains this value is not able to retrieve the secret hash without solving
the discrete logarithm problem, but verifier (in conjunction with the salt,
which is public) could still be used for nefarious purposes if obtained by an
intruder. Specifically, the intruder could pose as a man-in-the-middle when a
user attempts to connect to the group server. When the user sends his username,
the impostor responds with the corresponding salt. Then, the impostor is
capable of generating the appropriate <var>B = v + g<sup>b</sup></var>, because
<var>b</var> can be chosen arbitrarily and <var>g</var> is public information.
From there the protocol commences as usual, except between the user and the
impostor.</p>

<p>At the end of this exchange, the user is securely connected and
authenticated to the impostor, but is left falsely believing that the impostor
is the group server due to the verifier having been leaked. At this point the
user normally requests a token, to which the impostor could respond with some
random fraudulent token. If the user uses this token to access a file server
it will fail, but if he continues to communicate with the fake group server
in order to perform group operations, the impostor can gain a complete record
of that user’s session. This is both a denial of service and a means by which
information about groups and users can be obtained.</p>

<!-- END CHANGES HERE -->
    </section>
    <section id="countermeasure">
      <h2>Countermeasures</h2>
<!-- BEGIN CHANGES HERE -->

<h3>Token Hoarding and Theft</h3>
<p>Our solution will involve incorporating a timestamp into each token. The
timestamp will be divided into some level of granularity and incorporated into
the hash of the token. After enough time passes, the timestamp (and thus the
hash) of the token will change, rendering it invalid. After a token expires,
the user will be required to request a new one from from the group server,
which enforces the restrictions imposed by changes in group membership.</p>

<p>This timestamp will be incorporated in the same way that the various other
components of the token (subject, issuer, groups, server fingerprint) were,
i.e. it will be converted to a unique byte-level representation and joined with
the other components to form a unique byte string. This string is then hashed
and the hash is signed with the group server’s private key.</p>

<p>The timestamp needn’t be complicated to achieve its purpose. Our
implementation will utilize the operating system’s clock to obtain the number
of milliseconds since the UNIX epoch, which will then be divided by the number
of milliseconds in the maximum period for which a token may remain valid. We
plan to set this period to one hour, but it can be trivially configured to some
other time.</p>

<p>There are two things that ought to be considered about this implementation.
First, tokens remain valid relative not to the time of issuance but to the
times of the servers. This means that a user may run into a circumstance in
which he requests a token shortly before the turn of the hour, only for it to
be invalidated shortly thereafter. This is more of a usability quirk than a
security consideration (although proponents of the principle of psychological
acceptability would argue otherwise), and could be solved by modifying the
client to automatically request a new token once the old one expires. Second,
this imposes a new requirement on the system: the group server and the file
servers must maintain a mostly-synchronized perception of time, lest the group
server issue a token which a desynchronized file server believes is expired.
We assume that this synchronization requirement will be satisfied by means
external to our system, e.g. implementations of the NTP or PTP protocols.</p>

<h3>File Server File Tampering</h3>
<p>Although there is no way to prevent the file server from tampering files
stored on it, we can detect this and protect the user from any issues it could
cause. In order to protect the integrity of the stored files, we will use a
SHA-256 hash of the plaintext of the file as an integrity check. This hash
will be computed by the user and sent to the file server, which stores it
with the rest of the file’s metadata. Because the hash will be made on the
plaintext of the file rather than the ciphertext, the hash need not be keyed to
prevent a file server from modifying the file and recomputing the hash. Upon
downloading and decrypting the file, a user will put the resulting plaintext
through the hash function and compare it with the hash that was stored in
the file metadata. If the two do not match, the client will dispose of the
downloaded file knowing it was tampered with.</p>

<h3>(D)DOS</h3>
<p>The threat of DOS attacks is a difficult one to mitigate, mainly because
there’s no principled way to determine whether a particular pattern of resource
usage is legitimate on the behalf of a user or is meant to deny service. There
are, however, several useful choices we can make based on assumptions about
user behavior.</p>

<p>It would be unlikely for a legitimate user to have a need for opening
a connection with the group server and not using it. This is what the
<code>DOS.java</code> tool does, and continues to do until the group server
runs out of available socket descriptors and crashes. To address this, the
group server could enforce time limits on inactive connections, allowing it to
free resources associated with them.</p>

There are parallels to be drawn between DOS attacks and password brute forcing.
In both threats, there must be some arbitration between acceptable usage
(for DOS, any interaction that uses scarce resources; for password guessing,
a legitimate but incorrect attempt at logging in) and unacceptable usage
(consuming resources to the effect of denying other users service; entering
incorrect passwords with the hope of stumbling upon a correct one).

<h3>Password Brute Forcing</h3>
<p>It would be quite simple to make this sort of attack much more difficult. The
first countermeasure could be to implement rules that must be met when creating
a new password. This would would include things like a minimum length and
specifying how many letters, numbers, and special characters must be used. This
would most likely cause an annoyance to some users, but it would make a dictionary
attack less likely since the passwords would have a higher chance of being
unique and thus not be contained in the dictionary. A dictionary would need to
be exponentially bigger to account for passwords with a strong minimum length,
using a mix of numbers and letters (both uppercase and lowercase), and special
characters (@, #, %, ^, etc.).</p>

<p>Another way to protect the users from a dictionary attack is to implement
some sort of penalty for guessing a password wrong too many times. A common
way is to issue a timeout for a specified length of time. For example,
if a malicious user makes five passwords attempts in a row, and they all
fail, they could be locked out of trying for 10 minutes. Alternatively,
the server could implement exponential back-offs, requiring a user to
wait <var>t<sup>n</sup></var> seconds before being allowed to try again
after failing <var>n</var> times, and for some fixed <var>t</var>. This
countermeasure technically does not eliminate the possibility of a successful
brute force attack, but it certainly eliminates the feasibility of it.</p>

<h3>Group Server Impersonation</h3>
<p>This threat is somewhat impractical because it only arises when an attacker
has access to the verifiers stored by the group server. If the group server’s
local storage is compromised, it is almost entirely certain that its private
key will also be compromised, which is far more dangerous in an attacker’s
hands than the SRP verifiers.</p>

<p>However, it is significantly more obvious that allowing a private key to
be compromised is dangerous compared to a verifier. Because of this, a group
server administrator may be careless enough to only bother protecting the
private key, figuring that SRP saves him from having to worry about a password
database leak.</p>

<p>A solution for this would be to extend our existing protocol to incorporate
the group server’s keys into our authentication protocol. The simplest way to
do this would be for the user to send a random challenge value to the group
server encrypted with its public key, which it must then decrypt and send back
in plaintext. The changes to the protocol are shown in the protocol diagram
below, with <strong>bold face</strong> denoting the changes:</p>

<figure>
<dl>
  <dd>(All notation is the same as in phase 4’s write-up.)</dd>
  <dt>U &#8594; GS: <var>username</var></dt>
  <dt>U &#8592; GS: <var>salt</var></dt>
  <dt>U &#8594; GS: <var>A</var></dt>
  <dt>U &#8592; GS: <var>B</var></dt>
  <dt>
    U &#8594; GS:
    <span title="Client proof of identity"><var>M<sub>1</sub></var></span>,
    <span title="Key-based challenge">
        <strong><var>
            { C }<sub>K<sub>G</sub></sub>
        </var></strong>
    </span>
  </dt>
  <dt>
    U &#8592; GS:
    <span title="Server proof of identity"><var>M<sub>2</sub></var></span>,
    <span title="IV for cipher"><var>IV<sub>G</var></sub></span>,
    <span title="Key-based challenge response">
        <strong><var>C</var></strong>,
    </span>
    {
      <span title="Integrity key for MACs">
        <var>K<sub>i<sub>1</sub></sub></var>
      </span>
    }
    <span title="Symmetric key for U/GS from SRP exchange">
      <var>K<sub>UG</sub></var>
    </span>
  </dt>
</dl>
</figure>

<p>There is a trade-off here which leads us to believe that this change is not
worth making: It requires the users to know the group server’s public key,
which they were previously able to forgo. Because of this additional burden
on users, the low likelihood of an attacker gaining access only to the group
server’s stored verifiers but not its private key, and the relatively small
amount of information that can be obtained by impersonating the group server,
we decided not to implement this approach.</p>

<!-- END CHANGES HERE -->
    </section>
    <section id="discussion">
      <h2>Discussion</h2>
<!-- BEGIN CHANGES HERE -->

<p>Our choice of threats was motivated by both the practical experience from
having developed and worked with a real-world implementation and the design
principles we described in the first phase of the project. We managed to neatly
avoid the potential countermotivation of choosing a threat model based on which
threats can be neatly addressed given our current implementation, because our
design choices in previous phases were made with extendability and flexibility
in mind.</p>

<p>We implemented the token expiration solution for the token hoarding and
token theft threats, as well as the hash-based file integrity checks for the
file server file tampering threat. We also implemented a program which is
capable of bringing down the group server. We proposed some means by which the
group server can protect itself against DOS attacks, but left our discussion
largely open-ended on the matter of DDOS attacks. This is because it is very
difficult to design effective countermeasures in a system where one principal
poses such a juicy target and where an arbitrarily large number of distributed
attacks could be issued against it.</p>

<p>Finally, this phase revealed some interesting connections between the
various protocols we chose, designed, and/or implemented throughout the course
of this project. Now that we chose to address the issue of DOS, it began to
show up everywhere. File server chose to mess with some files? We can’t stop
it, but we can detect it. Attacker wants to repeatedly connect to the group
server in order to bring it down? We can identify individual attackers and
impose restrictions on them. Attacker wants to repeatedly attempt passwords to
gain access as another user? That’s rather similar to the previous situation.
In addition to the DOS connections, we were also able to bring together our
choice of the SRP protocol and the group server’s use of public keys in order
to address a weakness of the former, even though we did not go through with it
due to the trade-off.</p>

<p>Overall, we are pleased with the final result of this project. Were it an
implementation intended for use in the real world, it would now be at a stage
where it is ready to be audited by security professionals for implementation
errors before seeing its maiden deployment.</p>

<!-- END CHANGES HERE -->
    </section>
  </body>
</html>
